﻿// Chapter12 Project

// code isolation <good return> and reusability <functionality>

// methods -> primary reason we use methods is for reusability of code "DRY" priciple of programming
// classes -> code isolation, framework<access mod>, resource allocation<cpu,memory,data at rest, network>
// data at rest -> hard drive, memory, buffers, cache, ...
// data in transit -< network, service,...
// Thread class -> manage cpu threads
// Garbage Collection -> manage memory
// File IO class -> manage data at rest

// In C# it creates the Program.cs -> Program Class -> Program() constructor

// We group classes into namespace
// namespace does belong as a part of framework, it is more of an organization tool
// namespace -> alias
// Project Name -> Chapter12
using System.Security.Cryptography;

namespace Chapter12
{
    class Program  // default class for the .cs "name of the file"
    {

        // Main Runtime for the Application
        // public -> access mod "default"
        // static -> behavior mod
        // void -> return type
      
        static void Main(string[] args)
        {

            Console.WriteLine("My Main Application Starting Point");

            // New reason for using the "new" instance keyword
            // So we can import classes from other classes that we create or than are external to core C# classes

            // NEW INSTANCE OF AN EXTERNAL CLASS
            // Contacts Class in Contacts.cs
            Contacts contacts = new Contacts(); // created an instance of ALL objects in the Contacts Class (Contacts.cs) using the default constructor AS contacts in memory

            // use the obj name in memory<contacts> to access anything in the class
            contacts.contact1(); 
            contacts.contact2();

            Orders orders = new Orders();
            orders.customerOrders();

            // Ask the user for first name and last name
            Console.WriteLine("Enter first name: ");
            string firstName = Console.ReadLine();
            Console.WriteLine("Enter last name: ");
            string lastName = Console.ReadLine();
            string creationDate = DateTime.Now.ToString("MM-dd-yyyy HH:mm:ss");

            // Create a new instance of class object
            Chapter15.myFileIO(firstName, lastName, creationDate); // if the method you are using uses try/catch
            
            
            // no return keyword -> the program does not know what to do with the objects
            // return age -> age int  return int
            // void keyword voids objects in memory "other reason"
        } // Main()
        
        // Program() constructor
            
    } // class Program

    class Orders
    {
        public void customerOrders()
        {
            Console.WriteLine("Customer Orders Report");
        }
    
    } // Orders
        
} // namespace