﻿// Chapter 7

//  page 207
// try keyword catch required finally optional BUT highly recommended <pass or fail>

using System.Runtime.CompilerServices;

try
{
    double a; // try -> fails<catch> -> pass<ops><next op>
    a = 7.0; // try -> fails<catch> -> pass<ops><next op>
    double b; // try -> fails<catch> -> pass<ops><next op>
    b = 14.0; // try -> fails<catch> -> pass<ops><next op>
    double z = a / b; // try -> fails<catch> -> pass<ops><next op>
    Console.WriteLine(z); // try -> fails<catch> -> pass<ops><next op>

    // this step is going to fail Exit Code 1
    // int y = 10 / 0; // Divide by Zero Exception

    // other steps

    // nested try for specific reason
    try
    {
        // open a file I/O file does not exist
    }
    catch (FileNotFoundException e)
    {
        // do something
    }

} // try

// Catchs for the specific errors IN ORDER of priority
// catch keyword -> case statement with break;
catch (DivideByZeroException e)
{
    Console.WriteLine("Error occurred when dividing by zero");
    // log entry so the developer can fix this
    // or send the "Please enter a value greater than 0.

    // last step goes to finally keyword if exists or exits
}

catch (MyCustomException e)
{
    Console.WriteLine($"{e.Message}");
}

catch (FileNotFoundException e)
{
    Console.WriteLine($"{e} -> The file FILENAME, does not exist....");
}


// SQLExceptions -> bad un, bad pw, server not found, ...

catch (Exception e) // e obj is type class
{
    Console.WriteLine(e.ToString()); // string(string)
    Console.WriteLine($"{e.Message}"); // value output ignores string(class)

} // catch General Exception

finally // optional but recommended keyword
{
    Console.WriteLine("This is where you would do any operations if either the step passes or fails.");
}


// Class -> isolated reuseable block of code

// Exception object that we use in try/catch is a class type
// Create our own Exception classes based on custom events
public class MyCustomException : Exception
// <access mod> <return type> <Name> :<extends> <Base Class>
// public class CustomerDetails : Customer
{
    // Construct the message that gets sent to the program if an error occurs from this custom event
    // Constructor Statement  <access mod> ClassName() { }
    public MyCustomException(string message) : base(message)
    {
        Console.WriteLine("Event message... ");
    }

} // MyCustomException
