﻿// Chapter 8 Arrays and Collections

// Collection Classes OOP independent values collected together
/*
 * List -> indexed, change<CRUD>, dups, single  [] {}
 * Tuples -> index/positionalID, immutable, dups, single ()
 * Sets -> !indexed, !sorted, !dups, !change, single {}
 * Dictionary/Map -> key:value key!dup valueDup {"key1":value,"key2":value,...} 
 */

// Dimensional Arrays -> dependent values collected together

// "new" keyword -> creates an instance<var type class> of a class in memory in its own space
// variables -> stored in memory
// classes -> instance<var> to then store in memory
// string firstName;  // data type string variable named firstName
// Contact contactInfo; // class type Contact instance named contactInfo
// contactInfo.firstName<value>  contactInfo.myFullName()

// List -> many features to what a List can do
// DataSource<api,db,csv> -> List<string>
List<string> firstNames = new List<string>
{
    "Bob", "  Joe", "Mary", "JoE   ", "  MARK  ", "beth"
}; // firstNames
Console.WriteLine("---- Original List ----");
// foreach (x in ys) { }
//// x is the local variable in the {scope}  firstName
//// ys is the data set  firstNames
foreach (string firstName in firstNames) //len(), control, increment
{
    Console.WriteLine(firstName.Trim().ToUpper());
} // foreach
 
Console.WriteLine("---- End of Original List ----");

// add new firstnames to our list
// call the instance of the class from memory
Console.WriteLine("Enter a new contact name: ");
string newContact = Console.ReadLine();
firstNames.Add(newContact);

Console.WriteLine("---- New List ----");
foreach (string firstName in firstNames) //len(), control, increment
{
    Console.WriteLine(firstName.Trim().ToUpper());
} // foreach
Console.WriteLine("---- End of New List ----");

Console.WriteLine("---- Arrays ----");
// In C# lists can grow in size, aka, vary in length, ARRAYS<Dimensional Data> have FIXED lengths
// Have a control variable for the size of the array as int
int sizeArray = 3; // [0],[1],[2]

// New instance of an array
string[] arrayNames = new string[sizeArray];
// Option 1 could use the Add() to add elements to our list
// Option 2 use the index id to assign data
// Initial Data
arrayNames[0] = "Frank";
arrayNames[1] = "Bob";
arrayNames[2] = "Beth";

Console.WriteLine("---- Original Array List ----");
int contactID = 1;
foreach (string firstName in arrayNames) //len(), control, increment
{
    Console.WriteLine($"{contactID} -> {firstName}");
    contactID++;

} // foreach
Console.WriteLine("---- End of Array List ----");

Console.WriteLine("What contact ID to you want to update? ");
string updateID = Console.ReadLine();

// step 1 convert updateID to int
int id = int.Parse(updateID);  // assume digit

// step 2 decrement the int to index id
int i = id - 1;

// step 3 Ask the user the new contact name
string oldName = arrayNames[i];
Console.WriteLine($"What is {oldName}'s updated name?");
string newName = Console.ReadLine(); // Robert

// step 4 update the array
arrayNames[i] = newName;  // arrayNames[1] = "Robert"

Console.WriteLine("---- Updated Array List ----");
int contactID1 = 1;
foreach (string firstName in arrayNames) //len(), control, increment
{
    Console.WriteLine($"{contactID1} -> {firstName}");
    contactID1++;

} // foreach
Console.WriteLine("---- End of Array List ----");




